-----------------------------------------------------------------------------
-- Nom fichier      :  outils_adadoc-parser.ads                            --
-- Auteur           :  <a>Julien Burdy, Vincent Decorges EIA</a>           --
-- Date             :  <d>05.07.2001</d>                                   --
--                                                                         --
-- But              :  <p>Permet de parser une spcification Ada 95.       --
--                     Limitation : Ne supporte pas les renames et n'a pas --
--                     t test avec des specs pour l'orient objet ni pour--
--                     le temps rl</p>                                   --
--                                                                         --
-- Date de modif.   :                                                      --
-- Raison           :                                                      --
-- Modules appeles  :                                                      --
-- Mat. particulier :                                                      --
--                                                                         --
-- Compilation      : Gnat 3.11p sous NT 4                                 --
-- Edition de liens :                                                      --
-- Mode d'execution :                                                      --
-----------------------------------------------------------------------------

package Outils_Adadoc.Parser is

   ------------------------------------------------------------------------
   --    Nom   : Parser                                                  --
   -- <?>But   : Permet de parser une spec Ada 95                        --
   --                                                                    --
   --       Out: Tab_Symbole   : Pour stocker les symbole de la spec     --
   --    In    : Fichier       : Le fichier a parser</?>                 --
   ------------------------------------------------------------------------
   procedure Parser (Tab_Symbole : out T_PT_Objet;
                     Fichier : in Ada.Text_IO.File_Type);

   --<?>Lorsque le parser ne reconnait pas correctement le fichier</?>
   Parser_Erreur : exception;

end Outils_Adadoc.Parser;